﻿//=================================================================
//
//		   Camel Figurine Interacter - Plugin Version 1.4
//						Autor: katzerle
//			Honorbuddy Plugin - www.thebuddyforum.com
//        Credits to highvoltz and all the brave Testers
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
using System.Diagnostics;
using System.IO;
using System.Xml;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Windows.Media;
using System.Media;
using Styx.Common;
using Styx;
using Styx.CommonBot.Routines;
using Styx.Combat;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;
using Styx.CommonBot;
using Styx.CommonBot.Profiles;
using Styx.CommonBot.Frames;
using Styx.CommonBot.Inventory;

using Styx.Pathing;

namespace katzerle
{
    class Camel: HBPlugin
	{
		
		public static string name { get { return "Camel Figurine Interactor"; } }
		public override string Name { get { return name; } }
		public override string Author { get { return "katzerle"; } }
		private readonly static Version _version = new Version(1, 4);
		public override Version Version { get { return _version; } }
		public override string ButtonText { get { return "Settings"; } }
		public override bool WantButton { get { return true; } }
		public static LocalPlayer Me = ObjectManager.Me;
        public static CamelSettings Settings = new CamelSettings();

        struct Keys
        {
            public const char Up = (char)38;
            public const char Down = (char)40;
            public const char Left = (char)37;
            public const char Right = (char)39;
        }

		
        public Camel()
        {
            Log("Camel Figurine Interacter Version 1.4 Loaded.");
            Settings.Load();
        }

		public override void OnButtonPress()
		{
            Settings.Load();
            ConfigForm.ShowDialog();
        }

        private Form MyForm;
        public Form ConfigForm
        {
            get
            {
                if (MyForm == null)
                    MyForm = new CamelUI();
                return MyForm;
            }
        }

		public override void Pulse()
		{
			try
			{
                if (!inCombat)
				{
					findAndPickupObject();
					if (Settings.Dormus)
						findAndKillDormus();
				}
			}
			catch (ThreadAbortException) { }
			catch (Exception e)
			{
				Log("Plugin Camel: Exception in Pulse:{0}", e);
			}
		}

		static public void findAndPickupObject()
		{
            string File = "Plugins\\CamelFigurine\\";
            string sPath = Process.GetCurrentProcess().MainModule.FileName;
            sPath = Path.GetDirectoryName(sPath);
            sPath = Path.Combine(sPath, File);
            sPath = Path.Combine(sPath, "siren1.wav");

			ObjectManager.Update();
			List<WoWUnit> objList = ObjectManager.GetObjectsOfType<WoWUnit>()
                .Where(o => ((o.Entry == 50409) || (o.Entry == 50410) // 50409 might be the porting Camel Figurine
				))
				.OrderBy(o => o.Distance).ToList();
			foreach (WoWUnit o in objList)
			{
                if (!Blacklist.Contains(o.Entry))
                {
                    Log("Plugin Camel: Flying to Camel Figurine");
                    while (o.Location.Distance(Me.Location) > 5)
                        Flightor.MoveTo(o.Location);
                    if (inCombat) return;
                    Thread.Sleep(1000);
                    if (Settings.Alert)
                        new SoundPlayer(sPath).Play();
                    Logging.Write("Plugin Camel: Figurine Location: {0} / {1} / {2}", Convert.ToString(o.X), Convert.ToString(o.Y), Convert.ToString(o.Z));
                    Logging.Write("Plugin Camel: My Location: {0} / {1} / {2}", Convert.ToString(Me.X), Convert.ToString(Me.Y), Convert.ToString(Me.Z));
                    o.Interact();
                    Thread.Sleep(10000);
                    Log("Plugin Camel: Interact with Figurine - ID {0}", o.Entry);
                    if (o.Entry == 50410 && Settings.Collect)
                        Blacklist.Add(o.Entry, TimeSpan.FromSeconds(120));
                }
			}
		}
		
		static public void findAndKillDormus()
		{
            string File = "Plugins\\CamelFigurine\\";
            string sPath = Process.GetCurrentProcess().MainModule.FileName;
            sPath = Path.GetDirectoryName(sPath);
            sPath = Path.Combine(sPath, File);
            sPath = Path.Combine(sPath, "siren1.wav");

            ObjectManager.Update();
			List<WoWUnit> objList = ObjectManager.GetObjectsOfType<WoWUnit>()
                .Where(o => ((o.Entry == 50245)
				//|| (o.Entry == 45859) Testobject 
				))
				.OrderBy(o => o.Distance).ToList();
			foreach (WoWUnit o in objList)
			{
				if (!o.IsDead)
				{
					if (Settings.Alert)
						new SoundPlayer(sPath).Play();
					Log("Plugin Camel: Found Dormus.");

					if (RoutineManager.Current.NeedRest)
					{
						Log("Plugin Camel: CC says we need rest - Letting it do it before Fight.");
						RoutineManager.Current.Rest();
					}

					if (Me.Mounted)
						Mount.Dismount();
					o.Target();
					o.Face();
					Thread.Sleep(500);

					while(!inCombat)
					{
// ------------- Move to Dormus with Keypress -------------------					
						Log("Plugin Camel: Move to Dormus with Keys");
						while (o.Location.Distance(Me.Location) > 20)
						{
							o.Face();
							Thread.Sleep(500);
							KeyboardManager.PressKey(Keys.Up);
							Thread.Sleep(500);
							KeyboardManager.ReleaseKey(Keys.Up);
							if (inCombat) return;
							Thread.Sleep(100);
						}
						Thread.Sleep(200);
// ------------- Second Try to pull Dormus without Movement from this Point -------------------					
						o.Target();
						o.Face();
						WoWMovement.MoveStop();
						if(SpellManager.HasSpell(Settings.PullDormus))
							SpellManager.Cast(Settings.PullDormus);
						else if(SpellManager.HasSpell("Shadow Word: Pain"))
							SpellManager.Cast("Shadow Word Pain");
						else if(SpellManager.HasSpell("Ice Lance"))
							SpellManager.Cast("Ice Lance");
						else if(SpellManager.HasSpell("Charge"))
							SpellManager.Cast("Charge");
						else if(SpellManager.HasSpell("Serpent Sting"))
							SpellManager.Cast("Serpent Sting");
						else if(SpellManager.HasSpell("Thrown"))
							SpellManager.Cast("Thrown");
						else if(SpellManager.HasSpell("Icy Touch"))
							SpellManager.Cast("Icy Touch");
						else if(SpellManager.HasSpell("Hand of Reckoning"))
							SpellManager.Cast("Hand of Reckoning");
						else if(SpellManager.HasSpell("Flame Shock"))
							SpellManager.Cast("Flame Shock");
						else if(SpellManager.HasSpell("Corruption"))
							SpellManager.Cast("Corruption");
						else if(SpellManager.HasSpell("Moonfire"))
							SpellManager.Cast("Moonfire");
						WoWMovement.MoveStop(); 
						Thread.Sleep(500);
                        if (inCombat && o.CurrentTarget.IsMe) 
						{
							Log("Plugin Camel: Pulled Dormus (Distance: {0})", o.Location.Distance(Me.Location));
							return;
						}
						else
							Log("Plugin Camel: Pull fails", o.Name);						
					}
					Logging.Write("Plugin Camel: Mob Location: {0} / {1} / {2}", Convert.ToString(o.X), Convert.ToString(o.Y), Convert.ToString(o.Z));
					Logging.Write("Plugin Camel: My Location: {0} / {1} / {2}", Convert.ToString(Me.X), Convert.ToString(Me.Y), Convert.ToString(Me.Z));
				}
				else
				{
					Log("Plugin Camel: Find {0}, but he's dead", o.Name);
// ----------------- Loot Helper ---------------------
					if (o.CanLoot)
					{
						if (Me.Mounted)
							Mount.Dismount();
						o.Target();
// ------------- Move to Corpse with Keypress -------------------					
						Log("Plugin Camel: ... move to him to loot");
						while (o.Location.Distance(Me.Location) > 3)
						{
							o.Face();
							Thread.Sleep(500);
							KeyboardManager.PressKey(Keys.Up);
							Thread.Sleep(300);
							KeyboardManager.ReleaseKey(Keys.Up);
							if (inCombat) return;
							Thread.Sleep(300);
						}
						Thread.Sleep(500);
						WoWMovement.MoveStop();
						o.Interact();
						Thread.Sleep(2000);
						Lua.DoString("RunMacroText(\"/click StaticPopup1Button1\");");
						Thread.Sleep(4000);
						if(!o.CanLoot)
							Log("Plugin Camel: successfuly looted");
						else
							Log("Plugin Camel: Loot failed, try again");

					}
				}

			}
		}
		
		static public void Log(string msg, params object[] args) { Logging.Write(msg, args); }
		
		
        static public bool inCombat
        {
            get
            {
                if (Me.Combat || Me.IsDead || Me.IsGhost) return true;
                return false;
            }
        }

		public static int GetPing
		{
			get
			{
				return Lua.GetReturnVal<int>("return GetNetStats()", 2);
			}
		}
    }
}
